#pragma once

//         
class GradientColors {
public:
   enum ERGB {r,g,b,a};
private:
   struct CrlGradInfo { //    
      COLOR16 r,g,b,a; // RGB,    0x0000..0xff00
      bool direction[4]; //     rgb
   };
   USHORT m_delta; //   COLOR16
   UINT m_nColors; //   
   CrlGradInfo *m_pClrGrad; //    - array of gradient colors

   COLOR16& getColor_(UINT posColor, ERGB eByte);
   void Init();

public:
   GradientColors(UINT nColors, USHORT delta); // nColors -   ; delta -     
   GradientColors(UINT nColors);
  ~GradientColors();

   //    rgb    
   void NextIteration();

   COLOR16 getColor(UINT posColor, ERGB eByte) { return getColor_(posColor, eByte); } // 0x0000..0xff00

   // clarifier - : 0xFF - as is; 0x00 -  
   COLOR16 getColor(UINT posColor, ERGB eByte, BYTE clarifier) {
      COLOR16 clr = getColor_(posColor, eByte);
      if (0xFF == clarifier)
         return clr;
      clr = 0xFF00 - clr;
      return 0xFF00 - COLOR16(clr*(clarifier/255.));
   }
};