////////////////////////////////////////////////////////////////////////////////
// File name: Icon.h
// Author: Sergey Krivulya (Ce p) - KSerg (SeregaLBN)
// e-mail: Sergey_Krivulya@UkrPost.Net
// ICQ: 72099167
// WWW page: http://kserg77.narod.ru/Icon.html
// Date: 2007 07 02
//
// Description:   
// Copyright (C) 2007 Sergey Krivulya
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
////////////////////////////////////////////////////////////////////////////////

#ifndef __FILE__ICONS__
#define __FILE__ICONS__

#if _MSC_VER > 1000
   #pragma once
#endif // _MSC_VER > 1000

#include "../Resources.h"

//        ( 255   / )

//   ,   <-><->  

SIZE SizeIcon(HICON hIcon);
SIZE SizeIcon(WORD wIndexFrame, LPCTSTR szIcoFile); // size subicon (zero-based index)
SIZE SizeIcon(HMODULE hMod, WORD wIndexFrame, LPCTSTR szResourceName); //  (wIndexFrame)   (szResourceName)   RT_GROUP_ICON
SIZE SizeIcon(HMODULE hMod, WORD wIndexFrame, LPCTSTR szResourceName, WORD wIDLanguage); //  (wIndexFrame)   (szResourceName)   RT_GROUP_ICON c  
SIZE SizeIcon(HMODULE hMod, WORD wIcoId); //      id   RT_ICON
SIZE SizeIcon(WORD wIndexFrame, const BYTE *pbAllIcoFileData, DWORD nbSize); //  (wIndexFrame)    

WORD GetIconLang(HMODULE hMod, LPCTSTR szResourceName); //          RT_GROUP_ICON (    )
WORD GetIconCount(HMODULE hMod, BOOL bLang); //    DLL/EXE ( -  RT_GROUP_ICON). bLang -     
WORD GetIconFrames(LPCTSTR szIcoFile);                                      //    ICO  (subicon count)
WORD GetIconFrames(HMODULE hMod, LPCTSTR szResourceName);                   //          RT_GROUP_ICON
WORD GetIconFrames(HMODULE hMod, LPCTSTR szResourceName, WORD wIDLanguage); //          RT_GROUP_ICON   
WORD GetIconFrames(HMODULE hMod);                                           //       ( -  RT_ICON)
WORD GetIconFrames(const BYTE *pbAllIcoFileData, DWORD nbSize);             //        

BOOL GetIconGroupNames(  IN HMODULE hMod, OUT CRcName   *pNames, IN OUT WORD &wLenBuf); //      RT_GROUP_ICON
BOOL GetIconGroupNamesEx(IN HMODULE hMod, OUT CRcNameEx *pNames, IN OUT WORD &wLenBuf); //      RT_GROUP_ICON   

HICON LoadIcon(WORD wIndexFrame, LPCTSTR szIcoFile); // get subicon (zero-based index)
HICON LoadIcon(HMODULE hMod, WORD wIndexFrame, LPCTSTR szResourceName);                   //  (wIndexFrame)   (szResourceName)   RT_GROUP_ICON
HICON LoadIcon(HMODULE hMod, WORD wIndexFrame, LPCTSTR szResourceName, WORD wIDLanguage); //  (wIndexFrame)   (szResourceName)   RT_GROUP_ICON   
HICON LoadIcon(HMODULE hMod, WORD wIcoId); //      id   RT_ICON (id    == 0 , .. id   RT_ICON   )
HICON LoadIcon(WORD wIndexFrame, const BYTE *pbAllIcoFileData, DWORD nbSize); //        

BOOL ExtractIco( //    ico-   ico-
   IN WORD wIndexFrame,      //   (zero based)
   IN LPCTSTR szIcoFile,     // ico     ()
   IN LPCTSTR szIcoFileFrame //        (   !)
);
BOOL ExtractIco( //    RT_GROUP_ICON  ico-
   IN HMODULE hMod,
   IN LPCTSTR szResourceName, //     RT_GROUP_ICON
   IN LPCTSTR szIcoFile       //        (   !)
);
BOOL ExtractIco( //    RT_GROUP_ICON  ico-   
   IN HMODULE hMod,
   IN LPCTSTR szResourceName, //     RT_GROUP_ICON
   IN WORD wIDLanguage,
   IN LPCTSTR szIcoFile       //        (   !)
);
BOOL ExtractIco( //    RT_GROUP_ICON  ico-
   IN HMODULE hMod,
   IN WORD wIndexFrame,       //   (zero based)
   IN LPCTSTR szResourceName, //     RT_GROUP_ICON
   IN LPCTSTR szIcoFileFrame  //        (   !)
);
BOOL ExtractIco( //    RT_GROUP_ICON  ico-   
   IN HMODULE hMod,
   IN WORD wIndexFrame,       //   (zero based)
   IN LPCTSTR szResourceName, //     RT_GROUP_ICON
   IN WORD wIDLanguage,
   IN LPCTSTR szIcoFileFrame  //        (   !)
);
BOOL ExtractIco( //      id   RT_ICON  ico-
   IN HMODULE hMod,
   IN WORD wIcoId,           // id   RT_ICON (  )
   IN LPCTSTR szIcoFileFrame //        (   !)
);

#endif // __FILE__ICONS__
